import * as assets from 'monorepo-shared-assets';
import urge = assets.iter.fns.urge;
export declare function restrictedConcurrentActions<Y>(actions: restrictedConcurrentActions.ActionList<Y>, partLength: restrictedConcurrentActions.PartLength, handleRemain?: restrictedConcurrentActions.RemainingHandler<Y>): restrictedConcurrentActions.ReturningPromise<Y>;
export declare namespace restrictedConcurrentActions {
    type Action<Y> = () => Promise<Y>;
    type ActionList<Y> = Iterable<Action<Y>>;
    type PartLength = number;
    type RemainingHandler<Y> = urge.RemainingHandler<Action<Y>>;
    type ReturningValue<Y> = ReadonlyArray<Y>;
    type ReturningPromise<Y> = AsyncIterableIterator<ReturningValue<Y>>;
    const OMIT_EMPTY_REMAINING_PART: <X>(x: readonly X[]) => (readonly X[])[], KEEP_REMAINING_PART: <X>(x: X) => X[], OMIT_REMAINING_PART: () => never[], DEFAULT_REMAINING_HANDLER: <X>(x: readonly X[]) => (readonly X[])[];
    function asArray<Y>(actions: ActionList<Y>, partLength: PartLength, handleRemain?: RemainingHandler<Y>): asArray.ReturningPromise<Y>;
    namespace asArray {
        type ReturningValue<Y> = ReadonlyArray<restrictedConcurrentActions.ReturningValue<Y>>;
        type ReturningPromise<Y> = Promise<ReturningValue<Y>>;
    }
}
export default restrictedConcurrentActions;
